]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
04a4c144d091d88cfea2680107bea4d143473c37
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Notmuch helper functions
217 increment_mtime_amount=0
218 increment_mtime ()
219 {
220     dir="$1"
221
222     increment_mtime_amount=$((increment_mtime_amount + 1))
223     touch -d "+${increment_mtime_amount} seconds" "$dir"
224 }
225
226 # Generate a new message in the mail directory, with a unique message
227 # ID and subject. The message is not added to the index.
228 #
229 # After this function returns, the filename of the generated message
230 # is available as $gen_msg_filename and the message ID is available as
231 # $gen_msg_id .
232 #
233 # This function supports named parameters with the bash syntax for
234 # assigning a value to an associative array ([name]=value). The
235 # supported parameters are:
236 #
237 #  [dir]=directory/of/choice
238 #
239 #       Generate the message in directory 'directory/of/choice' within
240 #       the mail store. The directory will be created if necessary.
241 #
242 #  [filename]=name
243 #
244 #       Store the message in file 'name'. The default is to store it
245 #       in 'msg-<count>', where <count> is three-digit number of the
246 #       message.
247 #       
248 #  [body]=text
249 #
250 #       Text to use as the body of the email message
251 #
252 #  '[from]="Some User <user@example.com>"'
253 #  '[to]="Some User <user@example.com>"'
254 #  '[subject]="Subject of email message"'
255 #  '[date]="RFC 822 Date"'
256 #
257 #       Values for email headers. If not provided, default values will
258 #       be generated instead.
259 #
260 #  '[cc]="Some User <user@example.com>"'
261 #  [reply-to]=some-address
262 #  [in-reply-to]=<message-id>
263 #  [references]=<message-id>
264 #  [content-type]=content-type-specification
265 #  '[header]=full header line, including keyword'
266 #
267 #       Additional values for email headers. If these are not provided
268 #       then the relevant headers will simply not appear in the
269 #       message.
270 #
271 #  '[id]=message-id'
272 #
273 #       Controls the message-id of the created message.
274 gen_msg_cnt=0
275 gen_msg_filename=""
276 gen_msg_id=""
277 generate_message ()
278 {
279     # This is our (bash-specific) magic for doing named parameters
280     local -A template="($@)"
281     local additional_headers
282
283     gen_msg_cnt=$((gen_msg_cnt + 1))
284     if [ -z "${template[filename]}" ]; then
285         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
286     else
287         gen_msg_name=${template[filename]}
288     fi
289
290     if [ -z "${template[id]}" ]; then
291         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
292     else
293         gen_msg_id="${template[id]}"
294     fi
295
296     if [ -z "${template[dir]}" ]; then
297         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
298     else
299         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
300         mkdir -p "$(dirname "$gen_msg_filename")"
301     fi
302
303     if [ -z "${template[body]}" ]; then
304         template[body]="This is just a test message (#${gen_msg_cnt})"
305     fi
306
307     if [ -z "${template[from]}" ]; then
308         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
309     fi
310
311     if [ -z "${template[to]}" ]; then
312         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
313     fi
314
315     if [ -z "${template[subject]}" ]; then
316         template[subject]="Test message #${gen_msg_cnt}"
317     fi
318
319     if [ -z "${template[date]}" ]; then
320         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
321     fi
322
323     additional_headers=""
324     if [ ! -z "${template[header]}" ]; then
325         additional_headers="${template[header]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[reply-to]}" ]; then
330         additional_headers="Reply-To: ${template[reply-to]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[in-reply-to]}" ]; then
335         additional_headers="In-Reply-To: ${template[in-reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[cc]}" ]; then
340         additional_headers="Cc: ${template[cc]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[references]}" ]; then
345         additional_headers="References: ${template[references]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[content-type]}" ]; then
350         additional_headers="Content-Type: ${template[content-type]}
351 ${additional_headers}"
352     fi
353
354
355 cat <<EOF >"$gen_msg_filename"
356 From: ${template[from]}
357 To: ${template[to]}
358 Message-Id: <${gen_msg_id}>
359 Subject: ${template[subject]}
360 Date: ${template[date]}
361 ${additional_headers}
362 ${template[body]}
363 EOF
364
365     # Ensure that the mtime of the containing directory is updated
366     increment_mtime "$(dirname "${gen_msg_filename}")"
367 }
368
369 # Generate a new message and add it to the database.
370 #
371 # All of the arguments and return values supported by generate_message
372 # are also supported here, so see that function for details.
373 add_message ()
374 {
375     generate_message "$@" &&
376     notmuch new > /dev/null
377 }
378
379 # Generate a corpus of email and add it to the database.
380 #
381 # This corpus is fixed, (it happens to be 50 messages from early in
382 # the history of the notmuch mailing list), which allows for reliably
383 # testing commands that need to operate on a not-totally-trivial
384 # number of messages.
385 add_email_corpus ()
386 {
387     rm -rf ${MAIL_DIR}
388     if [ -d ../corpus.mail ]; then
389         cp -a ../corpus.mail ${MAIL_DIR}
390     else
391         cp -a ../corpus ${MAIL_DIR}
392         notmuch new >/dev/null
393         cp -a ${MAIL_DIR} ../corpus.mail
394     fi
395 }
396
397 test_begin_subtest ()
398 {
399     if [ -n "$inside_subtest" ]; then
400         exec 1>&6 2>&7          # Restore stdout and stderr
401         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
402     fi
403     test_subtest_name="$1"
404     # Remember stdout and stderr file descriptios and redirect test
405     # output to the previously prepared file descriptors 3 and 4 (see
406     # bellow)
407     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
408     exec 6>&1 7>&2 >&3 2>&4
409     inside_subtest=t
410 }
411
412 # Pass test if two arguments match
413 #
414 # Note: Unlike all other test_expect_* functions, this function does
415 # not accept a test name. Instead, the caller should call
416 # test_begin_subtest before calling this function in order to set the
417 # name.
418 test_expect_equal ()
419 {
420         exec 1>&6 2>&7          # Restore stdout and stderr
421         inside_subtest=
422         test "$#" = 3 && { prereq=$1; shift; } || prereq=
423         test "$#" = 2 ||
424         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
425
426         output="$1"
427         expected="$2"
428         if ! test_skip "$@"
429         then
430                 if [ "$output" = "$expected" ]; then
431                         test_ok_ "$test_subtest_name"
432                 else
433                         testname=$this_test.$test_count
434                         echo "$expected" > $testname.expected
435                         echo "$output" > $testname.output
436                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
437                 fi
438     fi
439 }
440
441 test_expect_equal_failure ()
442 {
443         test "$#" = 3 && { prereq=$1; shift; } || prereq=
444         test "$#" = 2 ||
445         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
446
447         output="$1"
448         expected="$2"
449         if ! test_skip "$@"
450         then
451                 if [ "$output" = "$expected" ]; then
452                         test_known_broken_ok_ "$test_subtest_name"
453                 else
454                         test_known_broken_failure_ "$test_subtest_name"
455                 fi
456     fi
457 }
458
459 NOTMUCH_NEW ()
460 {
461     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
462 }
463
464 notmuch_search_sanitize ()
465 {
466     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
467 }
468
469 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
470 notmuch_show_sanitize ()
471 {
472     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
473 }
474
475 # End of notmuch helper functions
476
477 # Use test_set_prereq to tell that a particular prerequisite is available.
478 # The prerequisite can later be checked for in two ways:
479 #
480 # - Explicitly using test_have_prereq.
481 #
482 # - Implicitly by specifying the prerequisite tag in the calls to
483 #   test_expect_{success,failure,code}.
484 #
485 # The single parameter is the prerequisite tag (a simple word, in all
486 # capital letters by convention).
487
488 test_set_prereq () {
489         satisfied="$satisfied$1 "
490 }
491 satisfied=" "
492
493 test_have_prereq () {
494         case $satisfied in
495         *" $1 "*)
496                 : yes, have it ;;
497         *)
498                 ! : nope ;;
499         esac
500 }
501
502 # You are not expected to call test_ok_ and test_failure_ directly, use
503 # the text_expect_* functions instead.
504
505 test_ok_ () {
506         test_success=$(($test_success + 1))
507         say_color pass "%-6s" "PASS"
508         echo " $@"
509 }
510
511 test_failure_ () {
512         test_failure=$(($test_failure + 1))
513         say_color error "%-6s" "FAIL"
514         echo " $1"
515         shift
516         echo "$@" | sed -e 's/^/        /'
517         if test "$verbose" != "t"; then cat test.output; fi
518         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
519 }
520
521 test_known_broken_ok_ () {
522         test_fixed=$(($test_fixed+1))
523         say_color pass "%-6s" "FIXED"
524         echo " $@"
525 }
526
527 test_known_broken_failure_ () {
528         test_broken=$(($test_broken+1))
529         say_color pass "%-6s" "BROKEN"
530         echo " $@"
531 }
532
533 test_debug () {
534         test "$debug" = "" || eval "$1"
535 }
536
537 test_run_ () {
538         test_cleanup=:
539         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
540         eval >&3 2>&4 "$1"
541         eval_ret=$?
542         eval >&3 2>&4 "$test_cleanup"
543         return 0
544 }
545
546 test_skip () {
547         test_count=$(($test_count+1))
548         to_skip=
549         for skp in $NOTMUCH_SKIP_TESTS
550         do
551                 case $this_test.$test_count in
552                 $skp)
553                         to_skip=t
554                 esac
555         done
556         if test -z "$to_skip" && test -n "$prereq" &&
557            ! test_have_prereq "$prereq"
558         then
559                 to_skip=t
560         fi
561         case "$to_skip" in
562         t)
563                 say_color skip >&3 "skipping test: $@"
564                 say_color skip "%-6s" "SKIP"
565                 echo " $1"
566                 : true
567                 ;;
568         *)
569                 false
570                 ;;
571         esac
572 }
573
574 test_expect_failure () {
575         test "$#" = 3 && { prereq=$1; shift; } || prereq=
576         test "$#" = 2 ||
577         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
578         if ! test_skip "$@"
579         then
580                 test_run_ "$2"
581                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
582                 then
583                         test_known_broken_ok_ "$1"
584                 else
585                         test_known_broken_failure_ "$1"
586                 fi
587         fi
588 }
589
590 test_expect_success () {
591         test "$#" = 3 && { prereq=$1; shift; } || prereq=
592         test "$#" = 2 ||
593         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
594         if ! test_skip "$@"
595         then
596                 test_run_ "$2"
597                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
598                 then
599                         test_ok_ "$1"
600                 else
601                         test_failure_ "$@"
602                 fi
603         fi
604 }
605
606 test_expect_code () {
607         test "$#" = 4 && { prereq=$1; shift; } || prereq=
608         test "$#" = 3 ||
609         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
610         if ! test_skip "$@"
611         then
612                 test_run_ "$3"
613                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
614                 then
615                         test_ok_ "$2"
616                 else
617                         test_failure_ "$@"
618                 fi
619         fi
620 }
621
622 # test_external runs external test scripts that provide continuous
623 # test output about their progress, and succeeds/fails on
624 # zero/non-zero exit code.  It outputs the test output on stdout even
625 # in non-verbose mode, and announces the external script with "* run
626 # <n>: ..." before running it.  When providing relative paths, keep in
627 # mind that all scripts run in "trash directory".
628 # Usage: test_external description command arguments...
629 # Example: test_external 'Perl API' perl ../path/to/test.pl
630 test_external () {
631         test "$#" = 4 && { prereq=$1; shift; } || prereq=
632         test "$#" = 3 ||
633         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
634         descr="$1"
635         shift
636         if ! test_skip "$descr" "$@"
637         then
638                 # Announce the script to reduce confusion about the
639                 # test output that follows.
640                 say_color "" " run $test_count: $descr ($*)"
641                 # Run command; redirect its stderr to &4 as in
642                 # test_run_, but keep its stdout on our stdout even in
643                 # non-verbose mode.
644                 "$@" 2>&4
645                 if [ "$?" = 0 ]
646                 then
647                         test_ok_ "$descr"
648                 else
649                         test_failure_ "$descr" "$@"
650                 fi
651         fi
652 }
653
654 # Like test_external, but in addition tests that the command generated
655 # no output on stderr.
656 test_external_without_stderr () {
657         # The temporary file has no (and must have no) security
658         # implications.
659         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
660         stderr="$tmp/git-external-stderr.$$.tmp"
661         test_external "$@" 4> "$stderr"
662         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
663         descr="no stderr: $1"
664         shift
665         if [ ! -s "$stderr" ]; then
666                 rm "$stderr"
667                 test_ok_ "$descr"
668         else
669                 if [ "$verbose" = t ]; then
670                         output=`echo; echo Stderr is:; cat "$stderr"`
671                 else
672                         output=
673                 fi
674                 # rm first in case test_failure exits.
675                 rm "$stderr"
676                 test_failure_ "$descr" "$@" "$output"
677         fi
678 }
679
680 # This is not among top-level (test_expect_success | test_expect_failure)
681 # but is a prefix that can be used in the test script, like:
682 #
683 #       test_expect_success 'complain and die' '
684 #           do something &&
685 #           do something else &&
686 #           test_must_fail git checkout ../outerspace
687 #       '
688 #
689 # Writing this as "! git checkout ../outerspace" is wrong, because
690 # the failure could be due to a segv.  We want a controlled failure.
691
692 test_must_fail () {
693         "$@"
694         test $? -gt 0 -a $? -le 129 -o $? -gt 192
695 }
696
697 # test_cmp is a helper function to compare actual and expected output.
698 # You can use it like:
699 #
700 #       test_expect_success 'foo works' '
701 #               echo expected >expected &&
702 #               foo >actual &&
703 #               test_cmp expected actual
704 #       '
705 #
706 # This could be written as either "cmp" or "diff -u", but:
707 # - cmp's output is not nearly as easy to read as diff -u
708 # - not all diff versions understand "-u"
709
710 test_cmp() {
711         $GIT_TEST_CMP "$@"
712 }
713
714 # This function can be used to schedule some commands to be run
715 # unconditionally at the end of the test to restore sanity:
716 #
717 #       test_expect_success 'test core.capslock' '
718 #               git config core.capslock true &&
719 #               test_when_finished "git config --unset core.capslock" &&
720 #               hello world
721 #       '
722 #
723 # That would be roughly equivalent to
724 #
725 #       test_expect_success 'test core.capslock' '
726 #               git config core.capslock true &&
727 #               hello world
728 #               git config --unset core.capslock
729 #       '
730 #
731 # except that the greeting and config --unset must both succeed for
732 # the test to pass.
733
734 test_when_finished () {
735         test_cleanup="{ $*
736                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
737 }
738
739 test_done () {
740         GIT_EXIT_OK=t
741         test_results_dir="$TEST_DIRECTORY/test-results"
742         mkdir -p "$test_results_dir"
743         test_results_path="$test_results_dir/${0%.sh}-$$"
744
745         echo "total $test_count" >> $test_results_path
746         echo "success $test_success" >> $test_results_path
747         echo "fixed $test_fixed" >> $test_results_path
748         echo "broken $test_broken" >> $test_results_path
749         echo "failed $test_failure" >> $test_results_path
750         echo "" >> $test_results_path
751
752         echo
753
754         if [ "$test_failure" = "0" ]; then
755             rm -rf "$remove_tmp"
756             exit 0
757         else
758             exit 1
759         fi
760 }
761
762 test_emacs () {
763         # Construct a little test script here for the benefit of the user,
764         # (who can easily run "run_emacs" to get the same emacs environment
765         # for investigating any failures).    
766         cat <<EOF > run_emacs
767 #!/bin/sh
768 export PATH=$PATH
769 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
770
771 # We assume that the user will give a command-line argument only if
772 # wanting to run in batch mode.
773 if [ \$# -gt 0 ]; then
774         BATCH=--batch
775 fi
776
777 # Here's what we are using here:
778 #
779 # --batch:              Quit after given commands and print all (messages)
780 #
781 # --no-init-file        Don't load users ~/.emacs
782 #
783 # --no-site-file        Don't load the site-wide startup stuff
784 #
785 # --directory           Ensure that the local notmuch.el source is found
786 #
787 # --load                Force loading of notmuch.el
788 #
789 # notmuch-test-wait     Function for tests to use to wait for process completion
790 #
791 # message-signature     Avoiding appending user's signature on messages
792 #
793 # set-frame-width       80 columns (avoids crazy 10-column default of --batch)
794
795 emacs \$BATCH --no-init-file --no-site-file \
796         --directory ../../emacs --load notmuch.el \
797         --eval "(defun notmuch-test-wait ()
798                         (while (get-buffer-process (current-buffer))
799                                 (sleep-for 0.1)))" \
800         --eval "(setq message-signature nil)" \
801         --eval "(progn (set-frame-width (window-frame (get-buffer-window)) 80) \$@)"
802 EOF
803         chmod a+x ./run_emacs
804         ./run_emacs "$@"
805 }
806
807
808 find_notmuch_path ()
809 {
810     dir="$1"
811
812     while [ -n "$dir" ]; do
813         bin="$dir/notmuch"
814         if [ -x "$bin" ]; then
815             echo "$dir"
816             return
817         fi
818         dir="$(dirname "$dir")"
819         if [ "$dir" = "/" ]; then
820             break
821         fi
822     done
823 }
824
825 # Test the binaries we have just built.  The tests are kept in
826 # test/ subdirectory and are run in 'trash directory' subdirectory.
827 TEST_DIRECTORY=$(pwd)
828 if test -n "$valgrind"
829 then
830         make_symlink () {
831                 test -h "$2" &&
832                 test "$1" = "$(readlink "$2")" || {
833                         # be super paranoid
834                         if mkdir "$2".lock
835                         then
836                                 rm -f "$2" &&
837                                 ln -s "$1" "$2" &&
838                                 rm -r "$2".lock
839                         else
840                                 while test -d "$2".lock
841                                 do
842                                         say "Waiting for lock on $2."
843                                         sleep 1
844                                 done
845                         fi
846                 }
847         }
848
849         make_valgrind_symlink () {
850                 # handle only executables
851                 test -x "$1" || return
852
853                 base=$(basename "$1")
854                 symlink_target=$TEST_DIRECTORY/../$base
855                 # do not override scripts
856                 if test -x "$symlink_target" &&
857                     test ! -d "$symlink_target" &&
858                     test "#!" != "$(head -c 2 < "$symlink_target")"
859                 then
860                         symlink_target=../valgrind.sh
861                 fi
862                 case "$base" in
863                 *.sh|*.perl)
864                         symlink_target=../unprocessed-script
865                 esac
866                 # create the link, or replace it if it is out of date
867                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
868         }
869
870         # override notmuch executable in TEST_DIRECTORY/..
871         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
872         mkdir -p "$GIT_VALGRIND"/bin
873         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
874         OLDIFS=$IFS
875         IFS=:
876         for path in $PATH
877         do
878                 ls "$path"/notmuch 2> /dev/null |
879                 while read file
880                 do
881                         make_valgrind_symlink "$file"
882                 done
883         done
884         IFS=$OLDIFS
885         PATH=$GIT_VALGRIND/bin:$PATH
886         GIT_EXEC_PATH=$GIT_VALGRIND/bin
887         export GIT_VALGRIND
888 else # normal case
889         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
890         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
891 fi
892 export PATH
893
894 # Test repository
895 test="tmp.$(basename "$0" .sh)"
896 test -n "$root" && test="$root/$test"
897 case "$test" in
898 /*) TMP_DIRECTORY="$test" ;;
899  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
900 esac
901 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
902 rm -fr "$test" || {
903         GIT_EXIT_OK=t
904         echo >&5 "FATAL: Cannot prepare test area"
905         exit 1
906 }
907
908 MAIL_DIR="${TMP_DIRECTORY}/mail"
909 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
910
911 mkdir -p "${test}"
912 mkdir -p "${MAIL_DIR}"
913
914 cat <<EOF >"${NOTMUCH_CONFIG}"
915 [database]
916 path=${MAIL_DIR}
917
918 [user]
919 name=Notmuch Test Suite
920 primary_email=test_suite@notmuchmail.org
921 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
922 EOF
923
924
925 # Use -P to resolve symlinks in our working directory so that the cwd
926 # in subprocesses like git equals our $PWD (for pathname comparisons).
927 cd -P "$test" || error "Cannot setup test environment"
928
929 if test "$verbose" = "t"
930 then
931         exec 4>&2 3>&1
932 else
933         exec 4>test.output 3>&4
934 fi
935
936 this_test=${0##*/}
937 for skp in $NOTMUCH_SKIP_TESTS
938 do
939         to_skip=
940         for skp in $NOTMUCH_SKIP_TESTS
941         do
942                 case "$this_test" in
943                 $skp)
944                         to_skip=t
945                 esac
946         done
947         case "$to_skip" in
948         t)
949                 say_color skip >&3 "skipping test $this_test altogether"
950                 say_color skip "skip all tests in $this_test"
951                 test_done
952         esac
953 done
954
955 # Provide an implementation of the 'yes' utility
956 yes () {
957         if test $# = 0
958         then
959                 y=y
960         else
961                 y="$*"
962         fi
963
964         while echo "$y"
965         do
966                 :
967         done
968 }
969
970 # Fix some commands on Windows
971 case $(uname -s) in
972 *MINGW*)
973         # Windows has its own (incompatible) sort and find
974         sort () {
975                 /usr/bin/sort "$@"
976         }
977         find () {
978                 /usr/bin/find "$@"
979         }
980         sum () {
981                 md5sum "$@"
982         }
983         # git sees Windows-style pwd
984         pwd () {
985                 builtin pwd -W
986         }
987         # no POSIX permissions
988         # backslashes in pathspec are converted to '/'
989         # exec does not inherit the PID
990         ;;
991 *)
992         test_set_prereq POSIXPERM
993         test_set_prereq BSLASHPSPEC
994         test_set_prereq EXECKEEPSPID
995         ;;
996 esac
997
998 test -z "$NO_PERL" && test_set_prereq PERL
999 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1000
1001 # test whether the filesystem supports symbolic links
1002 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1003 rm -f y